.include "main.asm"
.include "twowire.asm"
.include "status.asm"

.def	Value = R16
.def	Lowbyte = R17
.def	Highbyte = R18
.def	Math = R19

.def	Slave = R20
.def	Function = R21

.def	Status = R22
.def	Routine = R23
.def	Errorcode = R24

; *********************************
; ***                           ***
; **                             **
; *   Peripherie initialisieren   *
; **                             **
; ***                           ***
; *********************************

Initialize:

; ****************************
; ***                      ***
; **                        **
; *   Ports initialisieren   *
; **                        **
; ***                      ***
; ****************************

in		Value, 0x17								; Directionregister PortB lesen
sbr		Value, 0x01								; Pin1 (PortB0) freigeben
sbr		Value, 0x02								; Pin2 (PortB1) freigeben
out		0x17, Value

; *****************************
; ***                       ***
; **                         **
; *   Zhler initialisieren   *
; **                         **
; ***                       ***
; *****************************

in		Value, 0x33								; Zhlerregister lesen
sbr		Value, 0x04								; Zhler starten
out		0x33, Value

in		Value, 0x39								; Zhlerregister lesen
sbr		Value, 0x02								; Zhler starten
out		0x39, Value

ldi		Value, 0xfa								; Pulsweite einstellen
out		0x3c, Value

; *******************************************
; ***                                     ***
; **                                       **
; *   Two - Wire Interface initialisieren   *
; **                                       **
; ***                                     ***
; *******************************************

in		Value, 0x36								; TWI - Register lesen
sbr		Value, 0x01								; Interrupt freigeben
sbr		Value, 0x04								; Interface freigeben
sbr		Value, 0x40								; Acknowledge freigeben
sbr		Value, 0x80								; Interrupt zurck setzen
out		0x36, Value

in		Value, 0x00								; TWI - Register lesen
sbr		Value, 0x02								; Bitrate setzen
out		0x00, Value

; *******************************************
; ***                                     ***
; **                                       **
; *   Two - Wire Interface initialisieren   *
; **                                       **
; ***                                     ***
; *******************************************

in		Value, 0x3b								; externes Interruptregister lesen
sbr		Value, 0x40								; Interrupt freigeben
out		0x3b, Value

in		Value, 0x35								; externes Interruptregister lesen
sbr		Value, 0x03								; "Rising Edge" einstellen
out		0x35, Value

; ***********************************
; ***                             ***
; **                               **
; *   Initialisierung abschlieen   *
; **                               **
; ***                             ***
; ***********************************

ldi		Value, 0x20								; Zhlerwert Status setzen
sts		0x0100, Value
ldi		Value, 0x04								; Zhlerwert "Pause" setzen
sts		0x0103, Value

ret
