; ***************************************
; ***                                 ***
; **                                   **
; *   Two - Wire Interface - Routinen   *
; **                                   **
; ***                                 ***
; ***************************************

twowire_Transmit_Startcondition:

in		Value, 0x36								; TWI - Register lesen
sbr		Value, 0x20								; Startcondition senden
sbr		Value, 0x80								; Interrupt zurck setzen
out		0x36, Value

twowire_Transmit_Startcondition_wait:

in		Value, 0x36								; TWI - Register lesen
sbrs	Value, 0x07								; Interrupt gesetzt?
rjmp	twowire_Transmit_Startcondition_wait	; Nein, also warten

in		Value, 0x01								; TWI - Statusregister lesen
andi	Value, 0xf8								; Prescalerbits ausblenden
cpi		Value, 0x08								; Startcondition akzeptiert?
breq	twowire_Transmit_Address				; Ja, also verzweige

ret

twowire_Transmit_Address:

cbr		Slave, 0x01								; "Writemode" setzen
out		0x03, Slave								; Adresse im Datenregister ablegen

in		Value, 0x36								; TWI - Register lesen
sbr		Value, 0x80								; Interrupt zurck setzen
out		0x36, Value

twowire_Transmit_Address_wait:

in		Value, 0x36								; TWI - Register lesen
sbrs	Value, 0x07								; Interrupt gesetzt?
rjmp	twowire_Transmit_Address_wait			; Nein, also warten

in		Value, 0x01								; TWI - Statusregister lesen
andi	Value, 0xf8								; Prescalerbits ausblenden
cpi		Value, 0x18								; Adresse & Acknowledge?
breq	twowire_Transmit_Function				; Ja, also verzweige

ret

twowire_Transmit_Function:

out		0x23, Function							; Functionbyte im Datenregister ablegen

in		Value, 0x36								; TWI - Register lesen
sbr		Value, 0x80								; Interrupt zurck setzen
out		0x36, Value

twowire_Transmit_Function_wait:

in		Value, 0x36								; TWI - Register lesen
sbrs	Value, 0x01								; Interrupt gesetzt?
rjmp	twowire_Transmit_Function_wait			; Nein, also warten

in		Value, 0x01								; TWI - Statusregister lesen
andi	Value, 0xf8								; Prescalerbits ausblenden
cpi		Value, 0x28								; Functionbyte & Acknowledge?
breq	twowire_Transmit_Lowbyte				; Ja, also verzweige

ret

twowire_Transmit_Lowbyte:

ret
